// testUkazFunDlg.cpp : implementation file
//

#include "stdafx.h"
#include "testUkazFun.h"
#include "testUkazFunDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
CString SelectNumRu(int nCat, int nSelRecCat, unsigned char* nu, int nSel)
{
    CString str,sstr;
   str.Format("RU:  cat%d:  =%d\r\n   ",nCat,nSelRecCat);
   for(int i=0; i<nSel; i++) 
   {
        sstr.Format("%d  ",nu[i]);
		str+=sstr;
   }
   return str;
}
CString SelectNumMar(int nCat, int nSelRecCat, unsigned char* nu, int nSel)
{
    CString str,sstr;
   str.Format("MAR:  cat%d:  =%d\r\n   ",nCat,nSelRecCat);
   for(int i=0; i<nSel; i++) 
   {
        sstr.Format("%d  ",nu[i]);
		str+=sstr;
   }
   return str;
}
CString SelectNumSvet(int nCat, int nSelRecCat, unsigned char* nu, int nSel)
{
    CString str,sstr;
   str.Format("SVET:  cat%d:  =%d\r\n   ",nCat,nSelRecCat);
   for(int i=0; i<nSel; i++) 
   {
        sstr.Format("%d  ",nu[i]);
		str+=sstr;
   }
   return str;
}
CString str2(int i)
{
    CString str;
	str.Format("stkoka=%d",i);
	return str;
}


/////////////////////////////////////////////////////////////////////////////
// CTestUkazFunDlg dialog

CTestUkazFunDlg::CTestUkazFunDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestUkazFunDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestUkazFunDlg)
	m_result = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestUkazFunDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestUkazFunDlg)
	DDX_Text(pDX, IDC_STATICres, m_result);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestUkazFunDlg, CDialog)
	//{{AFX_MSG_MAP(CTestUkazFunDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestUkazFunDlg message handlers

BOOL CTestUkazFunDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestUkazFunDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestUkazFunDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestUkazFunDlg::OnButton1() 
{
	unsigned char nu[]={0,1,2,3,4,5};

	OnParam(0,0,5,nu,6);
	
}

void CTestUkazFunDlg::OnButton2() 
{
	unsigned char nu[]={10,11,12};
	OnParam(1,2,10,nu,3);
}

void CTestUkazFunDlg::OnButton3() 
{
	unsigned char nu[]={100,200};
	OnParam(2,1,7,nu,2);
}



void CTestUkazFunDlg::OnParam(int iMode, int nCat, int nSelRecCat, unsigned char* nu, int nSel)
{
	CString (*FunAr[])(int,int , unsigned char*, int)={SelectNumRu,SelectNumMar,SelectNumSvet};
    m_result = FunAr[iMode](nCat,nSelRecCat,nu,nSel);

	CString (CTestUkazFunDlg::*pfun1)(int);
	pfun1=str1;
	m_result += pfun1(5);
	

	CString (*pfun2)(int);
	pfun2=str2;
	m_result += (pfun2(7));
	
	UpdateData(false);
}




CString CTestUkazFunDlg::str1(int i)
{
    CString str;
	str.Format("stkoka=%d");
	return str;
}
